//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
        
	using System.IO.Ports;   
	
    public partial class SerialComScript
	{
		public static SerialCom serialCom = null;
		
		static SerialComScript() 
		{
			serialCom = new SerialCom();
		}
		
		public void Send(string data)
		{
			serialCom.SendData(data);
		}
    }
	
	public class SerialCom
	{
		public SerialPort sPort = null;
		
		private Timer myTimer = new Timer();
		
		public SerialCom()
		{
			sPort = new SerialPort("COM5", 4800, Parity.None, 8, StopBits.One);
			sPort.Open();
			
			myTimer.Tick += new EventHandler(TimerEventProcessor);
			myTimer.Interval = 100;
			myTimer.Enabled = true;
		}

		public void SendData(string outData) {
			sPort.Write(outData);
		}
		
		public string buffer = "";
		
		private void TimerEventProcessor(Object myObject, EventArgs myEventArgs) 
		{			
			string tmp = "";
			
			try {
				tmp = sPort.ReadExisting();
			}
			catch (Exception) { return; }
			if (tmp.Length == 0) { return; }			
			
			//Put Code here to Handle Received Serial Data
			try {
				buffer = buffer + tmp;				
				if (buffer.Length > 10000) { buffer = ""; }

				float speedKnots = Globals.Tags.SpeedKnots.Value;
				float depthMeters = Globals.Tags.DepthMeters.Value;
				
				while (true)
				{
					int endIdx = -1;
					FindValue("$GPVTG", 5, ref endIdx, ref speedKnots);
					FindValue("$SDDPT", 1, ref endIdx, ref depthMeters);

					if (endIdx < 0)
					{
						break;
					}

					buffer = buffer.Substring(endIdx + 1);
				}
				Globals.Tags.SpeedKnots.SetAnalog(speedKnots);
				Globals.Tags.DepthMeters.SetAnalog(depthMeters);
			}
			catch (Exception) { }				
		}
		
		private void FindValue(string name, int loc, ref int endIdx, ref float newVal)
		{
			float retVal = 0;

			int idx1 = buffer.IndexOf(name);
			int idx2 = -1;
			if (idx1 >= 0)
			{
				//find loc
				for (int i = 0; i < loc; i++)
				{
					idx1 = buffer.IndexOf(",", idx1 + 1);
					if (idx1 < 0) { return; }
				}
				idx2 = buffer.IndexOf(",", idx1 + 1);
				if (idx2 < 0) { return; }
				if (idx2 > endIdx)
				{
					endIdx = idx2;
				}
				
				//extract value
				string retStr = buffer.Substring(idx1 + 1, idx2 - idx1 - 1);				
				try
				{
					retVal = float.Parse(retStr.Trim());
				}
				catch (Exception)
				{
					return;
				}		
				
				newVal = retVal;
			}
		}
	}
}
